--
-- DeleteIssuesbydate.sql
--
-- This script deletes issues (and related information) older than (or equal to) a date.
--
-- Before using this script two lines must be updated:
--
-- 1) (first line - Use ???) 
--    The ??? must be replaced with the database name you wish 
--    to update (default is RMT).
--
-- 2) (fourth line - set @FromDate = 'dd-mmm-yyyy')
--    The desired date must be put here. 
--    The format is dd-MMM-yyyy e.g. 01-JAN-2005.
--    The single quotes around the date are required.

Use ???
go

declare @FromDate as datetime

set @FromDate = 'dd-mmm-yyyy'

if exists(select * from INFORMATION_SCHEMA.TABLES where TABLE_NAME = 'IssueSignatures') begin
    declare @Sql varchar(8000) set @Sql =
        N'delete IssueSignatures
          from IssueSignatures
             inner join IssueHistory on IssueHistory.HistoryId = IssueSignatures.HistoryId
             inner join Issues on IssueHistory.IssueId = Issues.IssueId 
          where Issues.DateOpened <= CONVERT(datetime, ''' + convert(varchar(11), @FromDate, 101) + ''', 101)'
    execute(@Sql)
end

delete IssueHistory 
    from IssueHistory 
        inner join Issues on IssueHistory.IssueId = Issues.IssueId 
    where Issues.DateOpened <= @FromDate

delete IssueComments 
    from IssueComments 
        inner join Issues on IssueComments.IssueId = Issues.IssueId 
    where Issues.DateOpened <= @FromDate

delete IssueAttachmentThumbnails
    from IssueAttachmentThumbnails 
        inner join IssueAttachments on IssueAttachmentThumbnails.AttachmentId = IssueAttachments.AttachmentId
        inner join Issues on IssueAttachments.IssueId = Issues.IssueId 
    where Issues.DateOpened <= @FromDate

delete IssueAttachments
    from IssueAttachments 
        inner join Issues on IssueAttachments.IssueId = Issues.IssueId
    where Issues.DateOpened <= @FromDate

delete EMailNotifications
    from EMailNotifications 
        inner join Issues on EMailNotifications.IssueId = Issues.IssueId
    where Issues.DateOpened <= @FromDate

delete IssueLinks
    from IssueLinks
        inner join Issues on IssueLinks.LinkValue = Issues.IssueId
    where IssueLinks.LinkType = 'issue'
        and Issues.DateOpened <= @FromDate

delete IssueLinks
    from IssueLinks
        inner join Issues on IssueLinks.IssueId = Issues.IssueId
    where Issues.DateOpened <= @FromDate

delete EMailIssueSubscriptions
    from EMailIssueSubscriptions
        inner join Issues on EMailIssueSubscriptions.IssueId = Issues.IssueId
    where Issues.DateOpened <= @FromDate


delete Issues
    where Issues.DateOpened <= @FromDate