--
-- IssueRenumber.sql
--
-- This script is designed for RMTrack sites that use the "Number issues
-- sequentially within project" site option.
--
-- It will renumber the issue for each project starting at ONE and set the next
-- inssue number as "highest number within the project" + 1.
--
--
-- Before using this script one line must be updated:
-- 1) (first line - Use ???) 
--    The ??? must be replaced with the database name you wish 
--    to update (i.e. RMT).
--
USE ???
go

update i1
    set IssueNumber = Projects.IssueNumberingPrefix 
	+ cast((select count(*) 
                from Issues as i2
                where i2.IssueNumber <= i1.IssueNumber
		    and i2.ProjectId = i1.ProjectId) as varchar(20)) from Issues as i1 inner join Projects on Projects.ProjectId = i1.ProjectId 

update Projects
    set NextIssueNumber
        = (select count(*) from Issues where Issues.ProjectId =
Projects.ProjectId) + 1
from Projects
